Customize Column Headers

Users can customize the column headers width, caption and style.

Description
app.component.ts
index.html
app.component.html
styles.css
Copy to CodeMine

A user needs to follow these 3 steps to customize a view for tableSheet:

  1. Add table to the data manager
  2. Add a custom view, which has following properties:
interface IColumn {
    name: string; // the unique name of the column
    value?: string; // the value of the column, could be a field name of table from database, or formula which uses the fields names.
    caption?: string; // the caption of the column, which is the key of row data
    width?: number | string; // the width of the column, support number in pixel, or star size
    style?: GC.Data.StyleOptions; // the whole column style
    conditionalFormats?: Array<GC.Data.CellValueRuleOptions | GC.Data.SpecificTextRuleOptions | GC.Data.FormulaRuleOptions | GC.Data.DateOccurringRuleOptions | GC.Data.    Top10RuleOptions | GC.Data.UniqueRuleOptions | GC.Data.DuplicateRuleOptions | GC.Data.AverageRuleOptions | GC.Data.TwoScaleRuleOptions | GC.Data.ThreeScaleRuleOptions | GC.Data.DataBarRuleOptions | GC.Data.IconSetRuleOptions>;
    validator?: GC.Data.NumberValidatorOptions | GC.Data.DateValidatorOptions | GC.Data.TimeValidatorOptions | GC.Data.TextLengthValidatorOptions | GC.Data.FormulaValidatorOptions | GC.Data.FormulaListValidatorOptions | GC.Data.ListValidatorOptions;
    isPrimaryKey?: boolean; // mark the column as primary key column
    readonly?: boolean; // mark the column is readonly
    required?: boolean; // mark the column is required when insert a new row
    defaultValue?: any; // provide the default value when insert a new row, could be a const or a formula
    headerStyle?: GC.Data.HeaderStyleOptions; // the column header style.
}
  1. Set custom view into tableSheet. Users can set header style in view to customize the header style.

This is the sample code.

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
// add custom column header style
var headerStyle = {
    font: "italic bold 14pt Calibri",
    borderTop: {
        color: "lightgrey",
        style: "thick"
    },
    borderLeft: {
        color: "lightgrey",
        style: "thin"
    },
    borderRight: {
        color: "lightgrey",
        style: "thin"
    },
};
//add custom view
var myView = orderTable.addView("myView", [
    { value: "orderId", width: 100, headerStyle: headerStyle }, //set column width 100px
    { value: "orderDate", width: 200, headerStyle: headerStyle },
    { value: "freight", width: 100, headerStyle: headerStyle },
    { caption: "CompanyName", value: "customer.companyName", width: "2*", headerStyle: headerStyle }, //set column width with star size, which will calculate actual column width by the rest size of viewport
    { value: "customer.contactName", width: "*", headerStyle: headerStyle },
    { value: "customer.contactTitle", width: "*", headerStyle: headerStyle },
    { value: "=[@]", caption: "Address", width: "3*", headerStyle: headerStyle }
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
A user needs to follow these 3 steps to customize a view for tableSheet: Add table to the data manager Add a custom view, which has following properties: Set custom view into tableSheet. Users can set header style in view to customize the header style. This is the sample code.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import { Component, NgModule, enableProdMode } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { platformBrowserDynamic } from '@angular/platform-browser-dynamic'; import { SpreadSheetsModule } from '@mescius/spread-sheets-angular'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import './styles.css'; @Component({ selector: 'app-component', templateUrl: 'src/app.component.html' }) export class AppComponent { hostStyle = { width: '100%', height: '100%', overflow: 'hidden', float: 'left' }; constructor() { } initSpread($event: any) { let spread = $event.spread; spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Supplier"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //column headers style var headerStyle = { font: "italic 10pt Calibri" }; var headerStyle2 = { font: "12pt Calibri", backColor : "#F7A711", foreColor:"white", hAlign:"left", borderTop: { color: "black", style: "thick" }, borderLeft: { color: "black", style: "thick" }, borderRight: { color: "black", style: "thick" }, }; var headerStyle3 = { font: "bold 14pt Calibri", borderTop: { color: "blue", style: "thick" }, borderLeft: { color: "blue", style: "thin" }, borderRight: { color: "blue", style: "thin" }, }; //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [ { value: "Id", width: 80, headerStyle: headerStyle }, { value: "CompanyName", width: 200, caption :"Company Name", headerStyle: headerStyle }, { value: "ContactName", width: 150, caption :"Contact", headerStyle: headerStyle2 }, { value: "ContactTitle", width: 200, caption :"Title", headerStyle: headerStyle2 }, { value: "Address", width: 200, headerStyle: headerStyle3 }, { value: "City", width: 150, caption :"City", headerStyle: headerStyle3 }, { value: "State", width: 100, caption :"State" }, { value: "Region", width: 100, caption :"Region" } ]); sheet.setDataView(view); }); spread.resumePaint(); } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } @NgModule({ imports: [BrowserModule, SpreadSheetsModule], declarations: [AppComponent], exports: [AppComponent], bootstrap: [AppComponent] }) export class AppModule { } enableProdMode(); // Bootstrap application with hash style navigation and global services. platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Polyfills --> <script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script> <script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script> <!-- SystemJS --> <script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script> <script src="systemjs.config.js"></script> <script> // workaround to load 'rxjs/operators' from the rxjs bundle System.import('rxjs').then(function (m) { System.import('@angular/compiler'); System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators)); System.import('$DEMOROOT$/en/lib/angular/license.ts'); System.import('./src/app.component'); }); </script> </head> <body> <app-component></app-component> </body> </html>
<div class="sample-tutorial"> <gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)"> </gc-spread-sheets> </div>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'ts', typescriptOptions: { tsconfig: true }, meta: { 'typescript': { "exports": "ts" }, '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { 'core-js': 'npm:core-js/client/shim.min.js', 'zone': 'npm:zone.js/fesm2015/zone.min.js', 'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js', '@angular/core': 'npm:@angular/core/fesm2022', '@angular/common': 'npm:@angular/common/fesm2022/common.mjs', '@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs', '@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs', '@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs', '@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs', '@angular/router': 'npm:@angular/router/fesm2022/router.mjs', '@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs', 'jszip': 'npm:jszip/dist/jszip.min.js', 'typescript': 'npm:typescript/lib/typescript.js', 'ts': './plugin.js', 'tslib':'npm:tslib/tslib.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js', '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'ts' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' }, "node_modules/@angular": { defaultExtension: 'mjs' }, "@mescius/spread-sheets-angular": { defaultExtension: 'mjs' }, '@angular/core': { defaultExtension: 'mjs', main: 'core.mjs' } } }); })(this);

Customize Column Headers

Users can customize the column headers width, caption and style.

Description
app.jsx
app-func.jsx
app-class.jsx
index.html
styles.css
Copy to CodeMine

A user needs to follow these 3 steps to customize a view for tableSheet:

  1. Add table to the data manager
  2. Add a custom view, which has following properties:
interface IColumn {
    name: string; // the unique name of the column
    value?: string; // the value of the column, could be a field name of table from database, or formula which uses the fields names.
    caption?: string; // the caption of the column, which is the key of row data
    width?: number | string; // the width of the column, support number in pixel, or star size
    style?: GC.Data.StyleOptions; // the whole column style
    conditionalFormats?: Array<GC.Data.CellValueRuleOptions | GC.Data.SpecificTextRuleOptions | GC.Data.FormulaRuleOptions | GC.Data.DateOccurringRuleOptions | GC.Data.    Top10RuleOptions | GC.Data.UniqueRuleOptions | GC.Data.DuplicateRuleOptions | GC.Data.AverageRuleOptions | GC.Data.TwoScaleRuleOptions | GC.Data.ThreeScaleRuleOptions | GC.Data.DataBarRuleOptions | GC.Data.IconSetRuleOptions>;
    validator?: GC.Data.NumberValidatorOptions | GC.Data.DateValidatorOptions | GC.Data.TimeValidatorOptions | GC.Data.TextLengthValidatorOptions | GC.Data.FormulaValidatorOptions | GC.Data.FormulaListValidatorOptions | GC.Data.ListValidatorOptions;
    isPrimaryKey?: boolean; // mark the column as primary key column
    readonly?: boolean; // mark the column is readonly
    required?: boolean; // mark the column is required when insert a new row
    defaultValue?: any; // provide the default value when insert a new row, could be a const or a formula
    headerStyle?: GC.Data.HeaderStyleOptions; // the column header style.
}
  1. Set custom view into tableSheet. Users can set header style in view to customize the header style.

This is the sample code.

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
// add custom column header style
var headerStyle = {
    font: "italic bold 14pt Calibri",
    borderTop: {
        color: "lightgrey",
        style: "thick"
    },
    borderLeft: {
        color: "lightgrey",
        style: "thin"
    },
    borderRight: {
        color: "lightgrey",
        style: "thin"
    },
};
//add custom view
var myView = orderTable.addView("myView", [
    { value: "orderId", width: 100, headerStyle: headerStyle }, //set column width 100px
    { value: "orderDate", width: 200, headerStyle: headerStyle },
    { value: "freight", width: 100, headerStyle: headerStyle },
    { caption: "CompanyName", value: "customer.companyName", width: "2*", headerStyle: headerStyle }, //set column width with star size, which will calculate actual column width by the rest size of viewport
    { value: "customer.contactName", width: "*", headerStyle: headerStyle },
    { value: "customer.contactTitle", width: "*", headerStyle: headerStyle },
    { value: "=[@]", caption: "Address", width: "3*", headerStyle: headerStyle }
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
A user needs to follow these 3 steps to customize a view for tableSheet: Add table to the data manager Add a custom view, which has following properties: Set custom view into tableSheet. Users can set header style in view to customize the header style. This is the sample code.
import * as React from 'react'; import * as ReactDOM from 'react-dom'; import './styles.css'; import { AppFunc } from './app-func'; import { App } from './app-class'; // 1. Functional Component sample ReactDOM.render(<AppFunc />, document.getElementById('app')); // 2. Class Component sample // ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; export function AppFunc() { const initSpread = (spread) => { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Supplier"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //column headers style var headerStyle = { font: "italic 10pt Calibri" }; var headerStyle2 = { font: "12pt Calibri", backColor: "#F7A711", foreColor: "white", hAlign: "left", borderTop: { color: "black", style: "thick" }, borderLeft: { color: "black", style: "thick" }, borderRight: { color: "black", style: "thick" }, }; var headerStyle3 = { font: "bold 14pt Calibri", borderTop: { color: "blue", style: "thick" }, borderLeft: { color: "blue", style: "thin" }, borderRight: { color: "blue", style: "thin" }, }; //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [ { value: "Id", width: 80, headerStyle: headerStyle }, { value: "CompanyName", width: 200, caption: "Company Name", headerStyle: headerStyle }, { value: "ContactName", width: 150, caption: "Contact", headerStyle: headerStyle2 }, { value: "ContactTitle", width: 200, caption: "Title", headerStyle: headerStyle2 }, { value: "Address", width: 200, headerStyle: headerStyle3 }, { value: "City", width: 150, caption: "City", headerStyle: headerStyle3 }, { value: "State", width: 100, caption: "State" }, { value: "Region", width: 100, caption: "Region" } ]); sheet.setDataView(view); }); spread.resumePaint(); } return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => initSpread(spread)}> </SpreadSheets> </div> </div> ); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ import * as React from 'react'; import GC from '@mescius/spread-sheets'; import "@mescius/spread-sheets-tablesheet"; import { SpreadSheets } from '@mescius/spread-sheets-react'; import './styles.css'; const Component = React.Component; export class App extends Component { render() { return ( <div class="sample-tutorial"> <div class="sample-spreadsheets"> <SpreadSheets workbookInitialized={spread => this.initSpread(spread)}> </SpreadSheets> </div> </div> ); } initSpread(spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Supplier"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //column headers style var headerStyle = { font: "italic 10pt Calibri" }; var headerStyle2 = { font: "12pt Calibri", backColor : "#F7A711", foreColor:"white", hAlign:"left", borderTop: { color: "black", style: "thick" }, borderLeft: { color: "black", style: "thick" }, borderRight: { color: "black", style: "thick" }, }; var headerStyle3 = { font: "bold 14pt Calibri", borderTop: { color: "blue", style: "thick" }, borderLeft: { color: "blue", style: "thin" }, borderRight: { color: "blue", style: "thin" }, }; //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [ { value: "Id", width: 80, headerStyle: headerStyle }, { value: "CompanyName", width: 200, caption :"Company Name", headerStyle: headerStyle }, { value: "ContactName", width: 150, caption :"Contact", headerStyle: headerStyle2 }, { value: "ContactTitle", width: 200, caption :"Title", headerStyle: headerStyle2 }, { value: "Address", width: 200, headerStyle: headerStyle3 }, { value: "City", width: 150, caption :"City", headerStyle: headerStyle3 }, { value: "State", width: 100, caption :"State" }, { value: "Region", width: 100, caption :"Region" } ]); sheet.setDataView(view); }); spread.resumePaint(); } } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('$DEMOROOT$/en/lib/react/license.js').then(function () { System.import('./src/app'); }); </script> </head> <body> <div id="app" style="height: 100%;"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true, react: true }, meta: { '*.css': { loader: 'css' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'react': 'npm:react/umd/react.production.min.js', 'react-dom': 'npm:react-dom/umd/react-dom.production.min.js', 'css': 'npm:systemjs-plugin-css/css.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'jsx' }, "node_modules": { defaultExtension: 'js' }, } }); })(this);

Customize Column Headers

Users can customize the column headers width, caption and style.

Description
app.vue
index.html
styles.css
Copy to CodeMine

A user needs to follow these 3 steps to customize a view for tableSheet:

  1. Add table to the data manager
  2. Add a custom view, which has following properties:
interface IColumn {
    name: string; // the unique name of the column
    value?: string; // the value of the column, could be a field name of table from database, or formula which uses the fields names.
    caption?: string; // the caption of the column, which is the key of row data
    width?: number | string; // the width of the column, support number in pixel, or star size
    style?: GC.Data.StyleOptions; // the whole column style
    conditionalFormats?: Array<GC.Data.CellValueRuleOptions | GC.Data.SpecificTextRuleOptions | GC.Data.FormulaRuleOptions | GC.Data.DateOccurringRuleOptions | GC.Data.    Top10RuleOptions | GC.Data.UniqueRuleOptions | GC.Data.DuplicateRuleOptions | GC.Data.AverageRuleOptions | GC.Data.TwoScaleRuleOptions | GC.Data.ThreeScaleRuleOptions | GC.Data.DataBarRuleOptions | GC.Data.IconSetRuleOptions>;
    validator?: GC.Data.NumberValidatorOptions | GC.Data.DateValidatorOptions | GC.Data.TimeValidatorOptions | GC.Data.TextLengthValidatorOptions | GC.Data.FormulaValidatorOptions | GC.Data.FormulaListValidatorOptions | GC.Data.ListValidatorOptions;
    isPrimaryKey?: boolean; // mark the column as primary key column
    readonly?: boolean; // mark the column is readonly
    required?: boolean; // mark the column is required when insert a new row
    defaultValue?: any; // provide the default value when insert a new row, could be a const or a formula
    headerStyle?: GC.Data.HeaderStyleOptions; // the column header style.
}
  1. Set custom view into tableSheet. Users can set header style in view to customize the header style.

This is the sample code.

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
// add custom column header style
var headerStyle = {
    font: "italic bold 14pt Calibri",
    borderTop: {
        color: "lightgrey",
        style: "thick"
    },
    borderLeft: {
        color: "lightgrey",
        style: "thin"
    },
    borderRight: {
        color: "lightgrey",
        style: "thin"
    },
};
//add custom view
var myView = orderTable.addView("myView", [
    { value: "orderId", width: 100, headerStyle: headerStyle }, //set column width 100px
    { value: "orderDate", width: 200, headerStyle: headerStyle },
    { value: "freight", width: 100, headerStyle: headerStyle },
    { caption: "CompanyName", value: "customer.companyName", width: "2*", headerStyle: headerStyle }, //set column width with star size, which will calculate actual column width by the rest size of viewport
    { value: "customer.contactName", width: "*", headerStyle: headerStyle },
    { value: "customer.contactTitle", width: "*", headerStyle: headerStyle },
    { value: "=[@]", caption: "Address", width: "3*", headerStyle: headerStyle }
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
A user needs to follow these 3 steps to customize a view for tableSheet: Add table to the data manager Add a custom view, which has following properties: Set custom view into tableSheet. Users can set header style in view to customize the header style. This is the sample code.
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ <template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> </gc-spread-sheets> </div> </template> <script> import Vue from "vue"; import "@mescius/spread-sheets-vue"; import GC from "@mescius/spread-sheets"; import "@mescius/spread-sheets-tablesheet"; import "./styles.css"; let App = Vue.extend({ name: "app", methods: { initSpread: function (spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; //init a data manager var tableName = "Supplier"; var baseApiUrl = getBaseApiUrl(); var apiUrl = baseApiUrl + "/" + tableName; var dataManager = spread.dataManager(); var myTable = dataManager.addTable("myTable", { remote: { read: { url: apiUrl } } }); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //column headers style var headerStyle = { font: "italic 10pt Calibri" }; var headerStyle2 = { font: "12pt Calibri", backColor : "#F7A711", foreColor:"white", hAlign:"left", borderTop: { color: "black", style: "thick" }, borderLeft: { color: "black", style: "thick" }, borderRight: { color: "black", style: "thick" }, }; var headerStyle3 = { font: "bold 14pt Calibri", borderTop: { color: "blue", style: "thick" }, borderLeft: { color: "blue", style: "thin" }, borderRight: { color: "blue", style: "thin" }, }; //bind a view to the table sheet myTable.fetch().then(function () { var view = myTable.addView("myView", [ { value: "Id", width: 80, headerStyle: headerStyle }, { value: "CompanyName", width: 200, caption :"Company Name", headerStyle: headerStyle }, { value: "ContactName", width: 150, caption :"Contact", headerStyle: headerStyle2 }, { value: "ContactTitle", width: 200, caption :"Title", headerStyle: headerStyle2 }, { value: "Address", width: 200, headerStyle: headerStyle3 }, { value: "City", width: 150, caption :"City", headerStyle: headerStyle3 }, { value: "State", width: 100, caption :"State" }, { value: "Region", width: 100, caption :"Region" } ]); sheet.setDataView(view); }); spread.resumePaint(); }, }, }); function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } new Vue({ render: (h) => h(App), }).$mount("#app"); </script>
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- SystemJS --> <script src="$DEMOROOT$/en/vue/node_modules/systemjs/dist/system.src.js"></script> <script src="systemjs.config.js"></script> <script> System.import('./src/app.vue'); System.import('$DEMOROOT$/en/lib/vue/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }
(function (global) { System.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, meta: { '*.css': { loader: 'css' }, '*.vue': { loader: 'vue-loader' } }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, // map tells the System loader where to look for things map: { '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js', 'jszip': 'npm:jszip/dist/jszip.js', 'css': 'npm:systemjs-plugin-css/css.js', 'vue': 'npm:vue/dist/vue.min.js', 'vue-loader': 'npm:systemjs-vue-browser/index.js', 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', 'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js' }, // packages tells the System loader how to load when no filename and/or no extension packages: { src: { defaultExtension: 'js' }, rxjs: { defaultExtension: 'js' }, "node_modules": { defaultExtension: 'js' } } }); })(this);